#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

int main () {
  int fds[2];
  if ( -1 == pipe(fds) ) {
    perror("pipe");
    exit(EXIT_FAILURE);
  }
  switch ( fork() ) {
  case -1:
    perror("fork");
    exit(EXIT_FAILURE);
  case 0:
    if ( -1 == dup2(fds[1], STDOUT_FILENO) ) {
      perror("dup2");
      exit(EXIT_FAILURE);
    }
    close(fds[0]);
    close(fds[1]);
    execlp("ls", "ls", ".", NULL);
    perror("execlp");
    exit(EXIT_FAILURE);
 default:
    if ( -1 == dup2(fds[0], STDIN_FILENO) ) {
      perror("dup2");
      exit(EXIT_FAILURE);
    }
    close(fds[0]);
    close(fds[1]);
    execlp("wc", "wc", "-l", NULL);
    perror("execlp");
    exit(EXIT_FAILURE);
  }
}
