#include <pthread.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>

#define N 200000000

struct arg {
  int *tab;
  int size;
};

int min_aux(int *tab, int size) {
  int i;
  int min = tab[0];
  for (i = 1; i<size; i++) {
    if (tab[i] < min) { min = tab[i]; }
  }
  return min;
}

void *min_thread(void *arg) {
  int *tab = ((struct arg *) arg)->tab;
  int size = ((struct arg *) arg)->size;
  int *res;
  if ( NULL == (res = (int*) malloc(sizeof(int))) ) {
    perror("malloc");
    exit(EXIT_FAILURE);
  }
  *res = min_aux(tab, size);
  return res;
}

int minimum(int *tab, int size) {
  pthread_t tid[2];
  int err;
  struct arg arg0;
  struct arg arg1;
  int *res_aux0;
  int *res_aux1;
  int res;
  arg0.tab = tab;
  arg0.size = size / 2;
  arg1.tab = tab + size / 2;
  arg1.size = size - size / 2;
  if ( 0 != (err = pthread_create(&(tid[0]), NULL, min_thread, &arg0)) ) {
    fprintf(stderr, "pthread_create: %s", strerror(err));
    exit(EXIT_FAILURE);
  }
  if ( 0 != (err = pthread_create(&(tid[1]), NULL, min_thread, &arg1)) ) {
    fprintf(stderr, "pthread_create: %s", strerror(err));
    exit(EXIT_FAILURE);
  }
  if ( 0 != (err = pthread_join(tid[0], (void **)&res_aux0)) ) {
    fprintf(stderr, "pthread_join: %s", strerror(err));
    exit(EXIT_FAILURE);
  }
  if ( 0 != (err = pthread_join(tid[1], (void **)&res_aux1)) ) {
    fprintf(stderr, "pthread_join: %s", strerror(err));
    exit(EXIT_FAILURE);
  }
  if ( *res_aux0 < *res_aux1 ) {
    res = *res_aux0;
  } else {
    res = *res_aux1;
  }
  free(res_aux0);
  free(res_aux1);
  return res;
}

int main() {
  int *tab;
  int i;
  srandomdev();
  if ( NULL == (tab = (int *)malloc(N*sizeof(int))) ) {
    perror("malloc");
    exit(EXIT_FAILURE);
  }
  for (i=0; i < N; i++) {
    tab[i] = random();
  }
  printf ("min(tab) = %d = %d\n", minimum(tab, N), min_aux(tab, N));
  return 0;
}
